#ifndef TESTINGOBJ_H
#define TESTINGOBJ_H

#include "Standardincludes.h"

#include "LEDControllerObj.h"
#include "SwitchControllerObj.h"
#include "RS232CommunicatorObj.h"
#include "MCControllObj.h"
#include "RFControllerObj.h"

/***Hier sind alle Tests zusammengefasst, um main() weniger zuzumüllen*/

class TestingObj
{
    public:
        TestingObj(LEDControllerObj *newLEDCtrl,
                    SwitchControllerObj *newSwitchCtrl,
                    RS232CommunicatorObj *newSerialConnect,
                    MCControllObj *newMCC,
                    RFControllerObj *newRFController);
        ~TestingObj();

        bool Test_RS232_Send();
        bool Test_RS232_Receive();
        bool Test_RF_Send();
        bool Test_RF_Receive();

        bool Test_RF_BitCheck(); //probiert alle möglichen Bitwerte aus für sende/empfang



    private:
        LEDControllerObj *LEDCtrl;
        SwitchControllerObj *SwitchCtrl;
        RS232CommunicatorObj *SerialConnect;
        MCControllObj *MCC;
        RFControllerObj *RFController;
};

#endif // TESTINGOBJ_H
