/*
 */

#include "include/Standardincludes.h"

using namespace std;

#include "include/LEDControllerObj.h"
#include "include/SwitchControllerObj.h"
#include "include/RS232CommunicatorObj.h"
//#include "include/InterruptHandler.h"
#include "include/MCControllObj.h"
#include "include/RFControllerObj.h"
#include "include/TestingObj.h"
#include "include/DebugObj.h"

///TODO: gemäß gesammeltem wissen eine eigne funktionssamllung fürs senden schreiben!

//relevantes: http://www.mikrocontroller.net/topic/166815

int main(void)
{
    //instanzen erzeugen
    LEDControllerObj LEDCtrl;
    SwitchControllerObj SwitchCtrl;
    RS232CommunicatorObj SerialConnect;
    MCControllObj MCC;
    RFControllerObj RFController;
    TestingObj Tests(&LEDCtrl, &SwitchCtrl, &SerialConnect, &MCC, &RFController);
    DebugObj Debug(&LEDCtrl, &SwitchCtrl, &SerialConnect, &MCC, &RFController);

    //Melden, dass wir fertig sind
    LEDCtrl.blink(100, 1, true, true);
    SerialConnect.sendToPC((char*) "Booted successfully.\n");
    SerialConnect.sendToPC((char*) "Entering main Loop.\n");
    LEDCtrl.blink(50, 1, true, false);
    LEDCtrl.blink(50, 1, false, true);


    //einige tests laufen lassen
    Tests.Test_RS232_Send();
    Tests.Test_RS232_Receive();

    Debug.giveShell(); //TODO: in Debugklasse auslagern

    //sende empfamgsmode aussuchen lassen
    bool send = false;
    SerialConnect.sendToPC((char*) "Press the button to send, else wait 3 seconds.\n");
    for (int i = 0; i < 30; ++i)
    {
        if(SwitchCtrl.isPressed())
        {
            send = true;
            LEDCtrl.blink(5,1,true,true);
        }
        MCC.delay(10);
        LEDCtrl.blink(5,1,false,true);
    }

    if(send)
    {
        SerialConnect.sendToPC((char*) "Trying to send something.");
        Tests.Test_RF_Send();
    }
    else
    {
        SerialConnect.sendToPC((char*) "Trying to receive something.");
        Tests.Test_RF_Receive();
    }

    return 0;
}
